var express =   require("express");
var fs = require('fs');
var bodyParser =    require("body-parser");
var multer  =   require('multer');
var exec = require('child_process').exec;
var app =   express();

app.use(bodyParser.json());
app.use('/public', express.static(__dirname + '/public'));

var storage =   multer.diskStorage({
  destination: function (req, file, callback) {
    callback(null, './public/uploads');
  },
  filename: function (req, file, callback) {
    callback(null, file.originalname);
  }
});
var upload = multer({ storage : storage }).array('pdbs',10);

app.get('/',function(req,res){
      res.sendFile(__dirname + "/Index.html");
});

app.post('/api/pdb',function(req,res){
    upload(req,res,function(err) {
        //console.log(req.body);
        //console.log(req.files);


        var bodyList = "";
        filePath = __dirname + '/public/uploads/list.txt';

        for (var i = 0; i < req.files.length; i++) {
          bodyList += req.files[i].originalname + "\n";
        }
        //console.log(bodyList);

        const pms = new Promise(

          (resolve, reject) => {

            fs.writeFile(filePath, bodyList, function(err) {
              if(err) {
                  return console.log(err);
                  reject(err);
              }
              console.log("The file was saved!");
              resolve('Success');
            });
          }         
        );

        pms.then(
          function execPipe(){
            console.log("Executing pipe...");
            exec("bash ./public/uploads/pipe.sh", function(error, stdout, stderr){
              // console.log("Stderr: " + stderr);
              // console.log("Strout: " + stdout);
              // console.log("Error: " + error);

              if (error) {
                console.log(stderr);
                return res.end(stderr);
              }
              console.log(stdout);
              res.end("Success");
            });
          }

        );
        
          

        if(err) {
            return res.end("Error uploading file.");
        }
        //res.end("Success");
    });
});

app.listen(3000,function(){
    console.log("Working on port 3000");
});