
// handle upload of new pdbs
  $(document).ready(function() {
    $('#uploadForm').submit(function() {

      if(files.length === 1) {
        alert("Please upload at least two PDB files for comparison.");
        return false;
      } else {
        displayMessage("Computing alignment on: " + getNewProteinNames());
            $(this).ajaxSubmit({
                error: function(xhr) {
                  status('Error: ' + xhr.status);
                },
                success: function(response) {
                  console.log(response);
                  if(response !== "Success"){
                    displayMessage("Alignment failure")
                    alert(response);
                  } else {
                    redrawAll();
                    displayMessage("Computing comparative visualization for: " + getProteinNames());
                  }
                }
        });
        return false;
      }
    });    
  });

window.onresize = function(event) {
    redrawAll();
};

function displayMessage(s){
  $("#toBeAligned").val(s);
  displayedMessage = s;
}

// gets info about new uploaded data from input file field
  function getFileData(myFile){
    files = [];
    pdbFiles = [];
    newProteins = [];
    var f = "";
    for (var i = 0; i < myFile.files.length; i++) {
      var prot = myFile.files[i].name.substr(0,myFile.files[i].name.indexOf('.'));
      files.push(prot);
       newProteins.push(prot);
      f += prot;
    }

    //$("#toBeAligned").val("Proteins to be aligned: " + getProteinNames());
    //displayedMessage = "Proteins to be aligned: " + getProteinNames();
    displayMessage("Proteins to be aligned: " + getNewProteinNames());
    if(myFile.files.length === 2) {
      fastaFile = "./public/uploads/"+f+"/"+f+".fasta"; 
    } else {
      fastaFile = "./public/uploads/"+f+"/"+f+".ali";
    }
    for (var i = 0; i < myFile.files.length; i++) {
      pdbFiles[i] = f+"/"+myFile.files[i].name;
    }
    $("#submit_btn").removeAttr("disabled");
  }

  function getProteinNames(){
    var s = "";
    for (var i = 0; i < proteins.length-1; i++) { s += proteins[i] + ", ";}
    return s + proteins[proteins.length-1];
  }

  function getNewProteinNames(){
    var s = "";
    for (var i = 0; i < newProteins.length-1; i++) { s += newProteins[i] + ", ";}
    return s + newProteins[newProteins.length-1];
  }

//reads fasta file from server memory
  function readTextFile(file) {
      var rawFile = new XMLHttpRequest();
      rawFile.open("GET", file, false);
      rawFile.onreadystatechange = function () {
          if (rawFile.readyState === 4) {
              if (rawFile.status === 200 || rawFile.status == 0) {
                  fasta = rawFile.responseText;
              }
          } else {
              console.log("File not supported!");
          }
      }
      rawFile.send(null);
  }

//creates 
  function createDoubles(){

    alignedSS = alignedResidues.slice();

    for(var i = 0; i < proteins.length; i++){
      var indexAl = 0;
      var indexNotAl = 0;

      alignToNotAlign[i] = [];
      notAlignToAlign[i] = [];
    
      for (var j = 0; j < alignedSS[i].length-1; j++) {
        if(alignedSS[i].charAt(j) === '-'){
        } else {
          if(indexAl < ss[i].length){
            //console.log(alignedSS[i])
              alignedSS[i] = alignedSS[i].replaceAt(j, ss[i][indexAl]);
              notAlignToAlign[i][indexAl] = j;
              alignToNotAlign[i][j] = indexAl;
              indexAl++;
          }
        }
      }
    }
  }

  String.prototype.replaceAt=function(index, replacement) {
      return this.substr(0, index) + replacement+ this.substr(index + replacement.length);
  }


//Browse button shit
$(function() {

  // We can attach the `fileselect` event to all file inputs on the page
  $(document).on('change', ':file', function() {
    var input = $(this),
        numFiles = input.get(0).files ? input.get(0).files.length : 1,
        label = input.val().replace(/\\/g, '/').replace(/.*\//, '');
    input.trigger('fileselect', [numFiles, label]);
  });

  // We can watch for our custom `fileselect` event like this
  $(document).ready( function() {
      $(':file').on('fileselect', function(event, numFiles, label) {

          var input = $(this).parents('.input-group').find(':text'),
              log = numFiles > 1 ? numFiles + ' files selected' : label;

          if( input.length ) {
              input.val(log);
          } else {
              if( log ) alert(log);
          }

      });
  });
  
});